; GoldenRod/theme.jl

(defgroup GoldenRod-frame "GoldenRod Frame")

(defcustom GoldenRod:active-text "white"
  "Colour of active text."
  :group GoldenRod-frame
  :type color)

(defcustom GoldenRod:inactive-text "dark gray"
  "Colour of inactive text."
  :group GoldenRod-frame
  :type color)  

(defcustom GoldenRod:active-title "active-title.png"
  "Bar for active title."
  :group GoldenRod-frame
  :type file-name)
  
(defcustom GoldenRod:inactive-title "inactive-title.png"
  "Bar for inactive title."
  :group GoldenRod-frame
  :type file-name)

(let*
  (
    (font-colors (list GoldenRod:inactive-text
                       GoldenRod:active-text))
    
    (border-image (make-image "border.png"))
    (close-image (make-image "close.png"))
    (max-image (make-image "max.png"))
    (min-image (make-image "min.png"))
    (top-image (list (make-image GoldenRod:inactive-title)
                     (make-image GoldenRod:active-title)))

    (frame `(
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (left-edge . 0)
         (right-edge . 0)
         (height . 20)
         (top-edge . -20)
         (class . title))
        ((background . ,border-image)
         (left-edge . -1)
         (top-edge . -20)
         (bottom-edge . -6)
         (class . left-border))
        ((background . ,border-image)
         (right-edge . -1)
         (top-edge . -20)
         (bottom-edge . -6)
         (class . right-border))
        ((background . ,top-image)
         (left-edge . 0)
         (right-edge .0)
         (height . 6)
         (bottom-edge . -6)
         (class . bottom-border))
        
        ((background . ,close-image)
         (right-edge . 4)
         (top-edge . -16)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 19)
         (top-edge . -16)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 34)
         (top-edge . -16)
         (class . iconify-button))
      ))

     (shaped-frame `(
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (left-edge . 0)
         (right-edge . 0)
         (height . 20)
         (top-edge . -20)
         (class . title))
        ((background . ,border-image)
         (left-edge . -1)
         (top-edge . -20)
         (height . 20)
         (class . title))
        ((background . ,border-image)
         (right-edge . -1)
         (top-edge . -20)
         (height . 20)
         (class . title))
        
        ((background . ,close-image)
         (right-edge . 4)
         (top-edge . -16)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 19)
         (top-edge . -16)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 34)
         (top-edge . -16)
         (class . iconify-button))
      ))

    (transient-frame `(
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (left-edge . 0)
         (right-edge . 0)
         (height . 20)
         (top-edge . -20)
         (class . title))
        ((background . ,border-image)
         (left-edge . -1)
         (top-edge . -20)
         (bottom-edge . -6)
         (class . left-border))
        ((background . ,border-image)
         (right-edge . -1)
         (top-edge . -20)
         (bottom-edge . -6)
         (class . right-border))
        ((background . ,top-image)
         (left-edge . 0)
         (right-edge .0)
         (height . 6)
         (bottom-edge . -6)
         (class . bottom-border))
        
        ((background . ,close-image)
         (right-edge . 4)
         (top-edge . -16)
         (class . close-button))
      ))


     (shaped-transient-frame `(
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (left-edge . 0)
         (right-edge . 0)
         (height . 20)
         (top-edge . -20)
         (class . title))
        ((background . ,border-image)
         (left-edge . -1)
         (top-edge . -20)
         (height . 20)
         (class . title))
        ((background . ,border-image)
         (right-edge . -1)
         (top-edge . -20)
         (height . 20)
         (class . title))
        
        ((background . ,close-image)
         (right-edge . 4)
         (top-edge . -16)
         (class . close-button))
      ))

   )
      
  (add-frame-style 'GoldenRod
    (lambda (w type)
      (cond 
            ((eq type 'shaped) shaped-frame)
            ((eq type 'unframed) nil-frame)
            ((eq type 'transient) transient-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            (t frame))))            
)
